#include <avr/io.h>
#include "usart.h"
#define UDORD0 2
void usart_mspim_init (void) {
  UBRR0 = 0;
  XCK_DDR |= (1<<XCK);
  UCSR0C = (1<<UMSEL01) | (1<<UMSEL00) | (0<<UDORD0) | (0<<UCPHA0) | (0<<UCPOL0);
  UCSR0B = (0<<RXCIE0) | (0<<TXCIE0) | (0<<UDRIE0) | (1<<RXEN0) | (1<<TXEN0);
  UBRR0 = UBRR_VAL;
}

uint8_t usart_mspim_transceive (uint8_t data) {
  while ( !(UCSR0A & (1<<UDRE0)) );
  UDR0 = data;
  while ( !(UCSR0A & (1<<RXC0)) );
  return UDR0;
}

void usart_disable (void) {
  UCSR0B &= ~((1<<RXEN0) | (1<<TXEN0));
  while ( !(UCSR0A & (1<<TXC0)) );
}

void usart_enable (void) {
  UCSR0B |= ((1<<RXEN0) | (1<<TXEN0));
}
